package Utils;

import java.util.Collection;
import java.util.Iterator;
import java.util.Stack;

public class BranchingIterator<T> implements Iterator<T>{
	private Stack<T> remaining;
	public Stack<T> used;

	public BranchingIterator(Collection<? extends T> list) {
		remaining = new Stack<T>();
		remaining.addAll(list);
		used = new Stack<T>();
	}

	public BranchingIterator(T[] array) {
		remaining = new Stack<T>();
		for(T t : array)
			remaining.add(t);
		used = new Stack<T>();
	}

	public void rewind()
	{
		T val = used.pop();
		remaining.push(val);
	}
	
	public void rewind(int count)
	{
		for (int i = 0; i < count; i++) 
			rewind();
	}

	@Override
	public boolean hasNext() {
		return !remaining.isEmpty();
	}

	@Override
	public T next() {
		if(!hasNext())
			return null;
		T val = remaining.pop();
		used.push(val);
		return val;
	}

	@Override
	public void remove() {
		throw new UnsupportedOperationException();
	}
}
