package Utils;

import java.util.HashSet;
import java.util.Iterator;

import main.Graph;
import main.Node;

public class ConnCompIterator implements Iterator<HashSet<Node>> {

	private Graph g;
	private MarkingIterator<Node> nodeIterator;
	private HashSet<Node> lastComponent;
	public ConnCompIterator(Graph g) {
		this.g = g;
		nodeIterator = new MarkingIterator<Node>(g.nodes);
	}

	@Override
	public boolean hasNext() 
	{
		return nodeIterator.hasNext();
	}

	@Override
	public HashSet<Node> next() {
		if(!hasNext())
			return null;
		else
		{
			lastComponent = GraphUtils.expand(nodeIterator.next(), ExpandMode.both);
			nodeIterator.markAll(lastComponent);
			return lastComponent;
		}
	}

	@Override
	public void remove() {
		g.nodes.removeAll(lastComponent);
	}

}
