package Utils;

import java.util.HashSet;
import java.util.Iterator;

import main.Graph;
import main.Node;

public class ConnCompNodeIterator implements Iterator<Node> {

	//private Graph g;
	private MarkingIterator<Node> nodeIterator;
	
	private HashSet<Node> lastComponent;
	public ConnCompNodeIterator(Graph g) {
		//this.g = g;
		nodeIterator = new MarkingIterator<Node>(g.nodes);
	}

	@Override
	public boolean hasNext() 
	{
		return nodeIterator.hasNext();
	}

	@Override
	public Node next() 
	{
		if(!hasNext())
			return null;
		else
		{
			Node lastNode = nodeIterator.next();
			lastComponent = GraphUtils.expand(lastNode, ExpandMode.both);
			nodeIterator.markAll(lastComponent);
			return lastNode;
		}
	}
	
	public HashSet<Node> getLastComponent()
	{
		return lastComponent;
	}

	@Override
	public void remove() {
		throw new UnsupportedOperationException();
		//g.nodes.removeAll(lastComponent);
	}

}
