package Utils;

import java.util.Collection;
import java.util.Iterator;
import java.util.LinkedList;

public class MarkingIterator<T> implements Iterator<T> {

	//protected Graph g;
	private LinkedList<T> remaining;
	public MarkingIterator(Collection<T> collection) {
		//this.g = g;
		remaining = new LinkedList<T>(collection);
	}

	@Override
	public boolean hasNext() 
	{
		return remaining.size() >  0;
	}

	@Override
	public T next() {
		if(!hasNext())
			return null;
		else
			return remaining.poll();
	}

	@Override
	public void remove() {
		throw new UnsupportedOperationException();
	}

	public void mark(T element)
	{
		remaining.remove(element);
	}
	public void markAll(Collection<T> elements)
	{
		remaining.removeAll(elements);
	}
	
}
