package Utils;

public class Tuple<L,R> {
	public L left;
	public R right;
	public Tuple(L left, R right) {
		this.left = left;
		this.right = right;
	}

	@Override
	public int hashCode() {
		return (left==null?0:left.hashCode())
				+(right==null?0:right.hashCode());
	}

	@Override
	public boolean equals(Object obj) 
	{
		if(!(obj instanceof Tuple))
			return false;
		
		Tuple<?, ?> otherPair = (Tuple<?,?>) obj;
		return (isEqual(left, otherPair.left) && isEqual(right, otherPair.right))
				|| (isEqual(right, otherPair.left) && isEqual(left, otherPair.right));

	}

	private boolean isEqual(Object o1, Object o2)
	{
		return (o1 == null && o2 == null) || (o1 != null && o1.equals(o2));
	}
	
	public boolean contains(Object object)
	{
		return left == object || right == object;
	}
}
