package graphLoading;
import java.util.ArrayList;

public class GraphComponent 
{
	public ArrayList<Integer> nodeList;
	public ArrayList<IntBasedEdge> edgeList;
	public GraphComponent() {
		nodeList = new ArrayList<Integer>();
		edgeList = new ArrayList<IntBasedEdge>();
	}
	
	public void addEdge(IntBasedEdge e)
	{
		edgeList.add(e);
		if(!nodeList.contains(e.left))
			nodeList.add(e.left);
		if(!nodeList.contains(e.right))
			nodeList.add(e.right);
	}
	public boolean isConnected(IntBasedEdge e)
	{
		return nodeList.contains(e.left) || nodeList.contains(e.right);
	}
	
	public boolean addEdgeIfConnected(IntBasedEdge e)
	{
		if(!nodeList.contains(e.left) && !nodeList.contains(e.right))
			return false;
		edgeList.add(e);
		if(!nodeList.contains(e.left))
			nodeList.add(e.left);
		if(!nodeList.contains(e.right))
			nodeList.add(e.right);
		return true;
	}
	
	public void addAll(GraphComponent comp)
	{
		for(Integer n : comp.nodeList)
		{
			if(!nodeList.contains(n))
				nodeList.add(n);
		}
		edgeList.addAll(comp.edgeList);
	}
}
