//package main;
//
//import java.util.HashMap;
//
///**
// * Represents a normal name for a node which is usually a simple string.
// * But it may happen that due to applying a reduction rule a node must have different names for the different edges it is part of.
// * Example:
// * Let this be a simpple degree-2-path with cyclicNeighbours of A and I greater than 2: A-B-C-D-E-F-G-H-I
// * Then it may be reduced with PRR3 to A-B-X-G-H-I but the edge (B,X) should still be named (B,D) and (X,G) should be named (F,G)
// * So X needs 2 names.
// * And that is what this class is for.
// * @author Steffen Toborg
// */
//@Deprecated
//public class NodeName 
//{
//
//	/**
//	 * The default name for this node 
//	 */
//	final String defaultName;
//	
//	
//	private HashMap<Node, String> customNames;
//	private NodeName(String name, HashMap<Node, String> customNames) 
//	{
//		this.defaultName = name;
//		this.customNames = customNames;
//	}
//	
//	public NodeName(String name, Node defaultNode) 
//	{
//		this(name, new HashMap<Node, String>());
//		customNames.put(defaultNode, name);
//	}
//	
//	public String getDefaultName()
//	{
//		return defaultName;
//	}
//	
//	/**
//	 * Adds a new custom name for this node.
//	 * Example: this node is called X and (B,X) should still be named (B,D) 
//	 * then it should be: addName("D",B);
//	 * For more information see this class' documentation.
//	 * @param name The new name
//	 * @param node the other node of the specified edge
//	 */
//	public void addName(String name, Node node)
//	{
//		customNames.put(node, name);
//	}
//	
//	/**
//	 * Gets the name of this node for the edge with the given Node as the other node of the specified edge.
//	 * If no custom name is specified for the given node the default name will be returned.
//	 * Example: this node is called X and (B,X) should still be named (B,D) 
//	 * Then getName(B) should result "D"
//	 * For more information see this class' documentation.
//	 * @param name The new name
//	 * @param node the other node of the specified edge
//	 */
//	public String getName(Node otherNode)
//	{
//		return customNames.containsKey(otherNode) ? customNames.get(otherNode) : defaultName;
//	}
//	
//	@Override
//	public NodeName clone() 
//	{
//		return new NodeName(defaultName, new HashMap<Node, String>(customNames));
//	}
//	
//	
//	@Override
//	public String toString() {
//		return defaultName;
//	}
//}
