package main;

import java.util.Collection;

import Utils.Tuple;

/**
 * A path of nodes in a graph, has at least a start and an end node, in a cyclic path they may be the same.
 * @author Steffen Toborg
 *
 */
public abstract class Path {
	/**
	 * @return the first node of this path
	 */
	abstract Node getStart();
	
	/**
	 * @return the last node of this path
	 */
	abstract Node getEnd();
	
	public abstract Collection<Tuple<Node, Node>> getInnerEdges();
	
	public boolean isStartOrEnd(Node toCheck)
	{
		return toCheck == getStart() || toCheck == getEnd();
	}
}
