package main;

import Utils.Tuple;


public class Token //implements Comparable<Token>
{
	/**
	 * the number of the edges
	 * the same as the number of the second node -> edge e has nodes e-1 and e
	 */
	public int[] edges;
	Degree2Path path;
	
	public int generator;	
	public Token(Degree2Path path, int[] edges, int generator) {
		this.path = path;
		this.edges = edges;
		this.generator = generator;
	}
	
	public Tuple<Node, Node> getEdge(int e)
	{
		if(e == -1)
			return null;//TODO handle this case??
		Node n1 = path.pathNodes.get(e-1);
		Node n2 = path.pathNodes.get(e);
		return new Tuple<Node, Node>(n1,n2);
	}
	
	public boolean hasDeletedEdge()
	{
		for(int i = 0; i < edges.length; i++)
		{
			int e = edges[i];
			if(e == -1)
				continue;//TODO handle this case
			Node n1 = path.pathNodes.get(e-1);
			Node n2 = path.pathNodes.get(e);
			if(!n1.cyclicNeighbours.contains(n2))
				return true;
		}
		return false;
	}
}
