package main;

import java.util.ArrayList;
import java.util.Collection;

import Utils.Tuple;

/**
 * A simple path with exacly 2 nodes(start and end) and no inner path nodes
 * @author Steffen Toborg
 */
public class TwoNodesPath extends Path {
	Node start;
	Node end;

	public TwoNodesPath(Node start, Node end) 
	{
		this.start = start; 
		this.end = end;
	}

	@Override
	public Node getStart() {
		return start;
	}

	@Override
	public Node getEnd() {
		return end;
	}

	@Override
	public Collection<Tuple<Node, Node>> getInnerEdges() {
		ArrayList<Tuple<Node, Node>> result = new ArrayList<Tuple<Node,Node>>();
		result.add(new Tuple<Node, Node>(start, end));
		return result;
	}
}
