package reductionRules.tree;


import result.ResultList;
import main.Graph;
import main.Node;

/**
 * Tree Reduction Rule 1: 
 * Let n be a vertex with |L(n)| >= 2 then delete all but one Leaf in L(n)
 * @author Steffen Toborg
 */
public class TRR1_ReduceLeaves extends TreeReductionRule 
{
	@Override
	protected int applyRule(Graph g, Node n, TreeRedLPYSet thisLPY, ResultList resultList) 
	{
		while(thisLPY.L.size() > 1)
			deleteNode(g, thisLPY.L.poll(), true);
		return 0;
	}

	@Override
	public String getName() {
		return "Tree-Reduction-Rule 1: Reduce Leaves";
	}
}
