package result;

import java.util.HashSet;

import Utils.Tuple;

public abstract class ResultListEntry implements Comparable<ResultListEntry> {
	static int lastEntryNum = 0;

	int num;
	final boolean addedByDataReduction;
	public ResultListEntry(boolean addedByDataReduction) {
		num = lastEntryNum++;
		this.addedByDataReduction = addedByDataReduction;
	}
	
	public abstract int getSize();

	@Override
	public int compareTo(ResultListEntry o) {
		if(this.num < o.num)
			return -1;
		else if(this.num == o.num)
			return 0;
		else
			return 1;
	}

	public abstract void addDeletedEdges(HashSet<Tuple<String, String>> returnVal);
}
