package solving;

import java.util.HashMap;

import main.Graph;
import main.Node;

public class GraphCopy extends Graph
{
	private Graph originalGraph;
	private HashMap<Node, Node> originalToClone;
	//private HashMap<Node, Node> cloneToOriginal;

	public Graph getOriginal()
	{
		return originalGraph;
	}
	
	public Node getNodeClone(Node n)
	{
		return originalToClone.get(n);
	}

	public GraphCopy(Graph original) 
	{
		//super(original.initialNodesCount, original.initialEdgesCount);
		super(original.nodes.size(), original.initialEdgesCount);

		
		this.originalGraph = original;

		originalToClone = new HashMap<Node, Node>();
		//cloneToOriginal = new HashMap<Node, Node>();
		int index = 0;
		for(Node n : original.nodes)
		{
			Node clone = new Node(n.name, index++);
			clone.isCyclic = n.isCyclic;
			clone.setConsistent(n.isConsistent());
			this.nodes.add(clone);
			originalToClone.put(n, clone);
			//cloneToOriginal.put(c, n);
		}
		for(Node n : original.nodes)
		{
			Node c = originalToClone.get(n);
			for(Node neighbour : n.nonCyclicNeighbours)
				c.addNonCyclicNeighbour(originalToClone.get(neighbour));
			for(Node neighbour : n.cyclicNeighbours)
				c.addCyclicNeighbour(originalToClone.get(neighbour));
		}

		//GraphViewing.showGraphAndWaitForClose(this, "COPY");
		//markCyclicNodes();
	}
	/*private Node getOriginal(Node clone)
		{
			return cloneToOriginal.get(clone);
		}*/
}