package solving.circlesTree;

import java.util.ArrayList;
import java.util.LinkedList;

import main.Node;
import main.Path;
import Utils.Tuple;

public class PathBasedCircle extends PathBasedCircleTreeNode
{


	//Graph g;
	private LinkedList<Path> path;
	private Node firstNode;
	private boolean complete;
	public boolean destroyed;
	public ArrayList<Tuple<Node, Node>> innerEdges;


	public PathBasedCircle(Node firstNode, LinkedList<Path> circle) 
	{
		this.firstNode = firstNode;
		this.path = circle;
		this.complete = false;
		this.destroyed = false;
		this.innerEdges = new ArrayList<Tuple<Node,Node>>();
	}



	@Override
	public boolean isComplete() {
		return complete;
	}

	@Override
	public Node getFirstNode() {
		return firstNode;
	}

	@Override
	public void setComplete() 
	{
		complete = true;
		for(Path p : path)
		{
			innerEdges.addAll(p.getInnerEdges());
		}
	}



	@Override
	public void addToPath(Path p) {
		path.add(p);
	}

	@Override
	public int getEdgesCount() {
		return innerEdges.size();
	}
}
