package solving.circlesTree;

import java.util.ArrayList;

import Utils.Tuple;
import main.Node;
import main.Path;

public abstract class PathBasedCircleTreeNode
{
	abstract boolean isComplete();
	abstract Node getFirstNode();
	abstract void setComplete();
	abstract void addToPath(Path p);
	public abstract int getEdgesCount();

	public PathBasedCircleTreeNode() {
		neighbours = new ArrayList<Tuple<Path,PathBasedCircleTreeNode>>();
	}
	
	/**
	 * a list of neighbours and the degree2Paths leading to them
	 */
	public ArrayList<Tuple<Path, PathBasedCircleTreeNode>> neighbours;
}
