package solving.newSolver;

import java.awt.IllegalComponentStateException;
import java.util.ArrayList;

import main.Degree2Path;
import main.Graph;
import main.Node;
import reductionRules.Reduction;
import result.ResultList;
import solving.GraphCopy;
import visualization.Graph.GraphViewing;
import Utils.ExpandMode;
import Utils.GraphUtils;

public class SolvingUtils {
	public static Node validateCyclicAndFindHook(Node n, Node parent)
	{
		if(n.cyclicNeighbours.size() == 1)
		{
			n.setNonCyclic();
			return validateCyclicAndFindHook(GraphUtils.getOtherNeighbour(n, parent, ExpandMode.cyclic), n);
		}
		else if(n.cyclicNeighbours.size() == 0)
		{
			n.setNonCyclic();
			return null;
		}
		else
			return n;
	}

	public static int applyReductionForHooks(Graph g, ArrayList<Node> hooks, ResultList reducedList)
	{
		g.validateConsistency();
		int reduced = 0;
		//GraphCopy secureCopy = new GraphCopy(g);
		
		for (int i = 0; i < hooks.size(); i++) {
			Node hook = hooks.get(i);
			if(hook != null && hook.isCyclic )
			{
				reduced += Reduction.applyTreeReductionRules(g, hook, null, reducedList);
			}
		}
		g.validateConsistency();

//		GraphCopy secureCopy = new GraphCopy(g);
//		try{
		for (int i = 0; i < hooks.size(); i++) {
			Node hook = hooks.get(i);
			if(hook != null && hook.isCyclic && hook.cyclicNeighbours.size() == 2)
			{
				Degree2Path p = Degree2Path.getMaximumDegree2Path(hook, g);
				reduced += Reduction.applyPathReductionRules(g, p, reducedList);
			}
		}
//		}
//		catch(IllegalComponentStateException e)
//		{
//		GraphViewing.showGraphAndWaitForClose(secureCopy, "");
//		
//		
//		for (int i = 0; i < hooks.length; i++) {
//			if(hooks[i] != null && hooks[i].isCyclic )
//			{
//				reduced += Reduction.applyTreeReductionRules(secureCopy, secureCopy.getNodeClone(hooks[i]), null, reducedList);
//			}
//		}
//		
//		for (int i = 0; i < hooks.length; i++) {
//			Node hookClone = secureCopy.getNodeClone(hooks[i]);
//			if(hookClone != null && hookClone.isCyclic && hookClone.cyclicNeighbours.size() == 2)
//			{
//				Degree2Path p = Degree2Path.getMaximumDegree2Path(hookClone, secureCopy);
//				reduced += Reduction.applyPathReductionRules(secureCopy, p, reducedList);
//			}
//		}
//		GraphViewing.showGraphAndWaitForClose(secureCopy, "");
//		}
		if(reduced< 0)
			throw new IllegalComponentStateException();
		return reduced;
	}
	/*
	public static int findHookAndApplyReduction(Graph g, Node n1, Node n2, ResultList resultList)
	{
		Node hook = SolvingUtils.validateCyclicAndFindHook(n1, n2);
		if(hook == null)
			return 0;

		int reduced = 0;
		reduced += Reduction.applyTreeReductionRules(g, hook, null, resultList);

		if(hook.isCyclic && hook.cyclicNeighbours.size() == 2)//TODO: reduction besser nicht hier weil inkonsistent
		{
			Degree2Path p = Degree2Path.getMaximumDegree2Path(hook, g);
			reduced += Reduction.applyPathReductionRules(g, p, resultList);
		}
		return reduced;
	}*/
}
