package solving.oldSolver.steps;

import java.util.Collection;

import main.Graph;
import main.Node;
import main.Start;
import solving.BranchSolverStep_old;
import solving.circlesTree.PathBasedCircle;
import solving.circlesTree.PathBasedCircleTreeNode;
import solving.circlesTree.PathBasedCirclesTree;
import Utils.BranchingIterator;
import Utils.ConnCompIterator;
import Utils.GraphUtils;
import Utils.Tuple;

public class BSS2_SmallCircles extends BranchSolverStep_old {

	public BSS2_SmallCircles(BranchSolverStep_old nextStep) 
	{
		super(nextStep);
	}

	@Override
	public int start(Graph g, int k) {
		ConnCompIterator connectedIterator = new ConnCompIterator(g);
		int kRemaining = k;
		while(connectedIterator.hasNext())
		{
			Collection<Node> comp = connectedIterator.next();
			
			//PathBasedCirclesTree tree = new PathBasedCirclesTree(comp, g.findDegree2Paths(comp));
			//kRemaining = solveStep2_smallCircles(tree, tree.nodes.peek(), null, kRemaining);
			//kRemaining = solveStep2_smallCircles(g, kRemaining, new BranchingIterator<PathBasedCircleTreeNode>(tree.nodes));

			if(kRemaining == -1)
				return -1;
			//			kRemaining = goToNextStep(g, kRemaining, tree);
			//			if(kRemaining == -1)
			//				return -1;
		}
		return kRemaining;

	}

	private int solveStep2_smallCircles(Graph g, int k, BranchingIterator<PathBasedCircleTreeNode> iterator)
	{
		if(!iterator.hasNext())
		{
			//onBranchReturn();
			return goToNextStep(g, k);
		}

		PathBasedCircleTreeNode node = iterator.next();
		int edgesCount = node.getEdgesCount();
		if(edgesCount == 0 || edgesCount > 5)
		{
			int result = solveStep2_smallCircles(g, k, iterator);
			if(result < 0)
				iterator.rewind();
			return result;
		}

		PathBasedCircle c = (PathBasedCircle) node;//cant fail because then edgesCount would be 0
		c.destroyed = true;
		for(Tuple<Node, Node> e : c.innerEdges)
		{
			if(Start.useBranchTreeVisualization)
			{
				Edge edge = new Edge(e.left, e.right);
				OnBeforeChange(g, edge);
				GraphUtils.removeEdge(e.left, e.right);
				onEdgeDeleted(e.left, e.right);
				onAfterChange(g, edge);
			}
			else
				GraphUtils.removeEdge(e.left, e.right);


			int res = solveStep2_smallCircles(g, k-1, iterator);
			if(res >= 0)//if success
			{
				onBranchReturn();
				return res;
			}
			GraphUtils.addEdge(e.left, e.right);
		}
		c.destroyed = false;
		iterator.rewind();
		onBranchReturn();
		return -1;
	}

	@Override
	public String getName() {
		return "Branch-solver-step 2: Small circles";
	}
}
