package solving.oldSolver.steps;

import java.util.ArrayList;
import java.util.LinkedList;

import main.Degree2Path;
import main.Graph;
import main.Node;
import main.Token;
import reductionRules.Reduction;
import solving.BranchSolverStep_old;
import solving.GraphCopy;
import Utils.BranchingIterator;
import Utils.GraphUtils;
import Utils.Tuple;

public class BSS3_BranchOnTokens extends BranchSolverStep_old {

	public BSS3_BranchOnTokens(BranchSolverStep_old nextStep) 
	{
		super(nextStep);
	}

	@Override
	public int start(Graph g, int k) 
	{
		GraphCopy copy = new GraphCopy(g);//makeCopy(g);
		int usedK = 0;
		LinkedList<Tuple<String, String>> copyResults = new LinkedList<Tuple<String,String>>();
		
		//usedK += Reduction.applyTreeReductionRules(copy, copyResults); TODO FIXME
		//ArrayList<Degree2Path> paths = copy.findDegree2Paths();
		//usedK += Reduction.applyPathReductionRules(copy, paths, copyResults);TODO FIXME
		Reduction.removeCaterpillars(copy);

		//return k >= usedK ? 
		//		branchOnPaths(copy, new BranchingIterator<Degree2Path>(paths), k-usedK) : -1;
		return 0;//TODO FIXME
	}

	private int branchOnPaths(GraphCopy copy, BranchingIterator<Degree2Path> pathIterator, int k)
	{
		if(!pathIterator.hasNext())
			return k;

		Degree2Path path = pathIterator.next();
		int returnVal = branchOnTokens(copy, pathIterator, new BranchingIterator<Token>(path.tokens), k);
		if(returnVal < 0)
			pathIterator.rewind();
		return returnVal;
	}

	private int branchOnTokens(GraphCopy copy, BranchingIterator<Degree2Path> pathIterator, BranchingIterator<Token> tokenIterator, int k)
	{
		if(k < 0)
		{
			onBranchReturn();
			return -1;
		}

		if(!tokenIterator.hasNext())
			return branchOnPaths(copy, pathIterator, k);

		Token t = tokenIterator.next();
		if(t.hasDeletedEdge())
		{
			int result = branchOnTokens(copy, pathIterator, tokenIterator, k);
			if(result < 0)
				tokenIterator.rewind();
			return result;
		}

		for(int i = 0; i < t.edges.length; i++)
		{
			Tuple<Node, Node> e = t.getEdge(t.edges[i]);

			/*if(Start.useVisualization)
			{
				Edge originalEdge = new Edge(copy.getOriginal(e.left), copy.getOriginal(e.right));
				OnBeforeChange(copy.originalGraph, originalEdge);
				GraphUtils.removeEdge(e.left, e.right);
				onEdgeDeleted(originalEdge.n1, originalEdge.n2);
				onAfterChange(copy.originalGraph, originalEdge);
			}
			else*/
				GraphUtils.removeEdge(e.left, e.right);


			int res = branchOnTokens(copy, pathIterator, tokenIterator, k-1);
			if(res >= 0)
			{
				onBranchReturn();
				return res;
			}
			GraphUtils.addEdge(e.left, e.right);
		}
		tokenIterator.rewind();
		onBranchReturn();
		return -1;
	}

	/*private Graph makeCopy(Graph g)
	{
		LinkedList<Node> copiedNodes = new LinkedList<Node>();
		HashMap<Node, Node> originalToClone = new HashMap<Node, Node>();
		for(Node n : g.nodes)
		{
			Node c = new Node(n.name.clone(), n.index);
			copiedNodes.add(c);
			originalToClone.put(n, c);
		}
		for(Node n : g.nodes)
		{
			Node c = originalToClone.get(n);
			for(Node neighbour : n.nonCyclicNeighbours)
				c.addNonCyclicNeighbour(originalToClone.get(neighbour));
			for(Node neighbour : n.cyclicNeighbours)
				c.addNonCyclicNeighbour(originalToClone.get(neighbour));
		}
		return new Graph(copiedNodes, g.initialNodesCount, g.initialEdgesCount);
	}*/

	@Override
	public String getName() {
		return "Branch-solver-step 3: Branch on tokens";
	}


}
