package visualization.BranchingTree;

import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Stack;

import javax.swing.JButton;
import javax.swing.JFrame;

import edu.uci.ics.jung.visualization.GraphZoomScrollPane;
import edu.uci.ics.jung.visualization.control.CrossoverScalingControl;
import edu.uci.ics.jung.visualization.control.ScalingControl;

import solving.BranchSolverStep_old;
import visualization.GraphComponent;

public class TreeViewFrame extends JFrame {

	private static final long serialVersionUID = 1L;

	private TreeViewer treeViewer;
	private GraphZoomScrollPane panel;
	private Stack<BranchTreeNode> stack;

	//private BranchTree
	public TreeViewFrame() {
		super("Branch Tree Viewer");

		this.setLayout(new BorderLayout());
		
		treeViewer = new TreeViewer(new BranchTreeNode(null, null));
		panel = new GraphZoomScrollPane(treeViewer);
		this.add(panel, BorderLayout.CENTER);

		stack = new Stack<BranchTreeNode>();
		this.pack();

		final ScalingControl scaler = new CrossoverScalingControl();

		JButton plus = new JButton("+");
		plus.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				scaler.scale(treeViewer, 1.1f, treeViewer.getCenter());
			}
		});
		JButton minus = new JButton("-");
		minus.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				scaler.scale(treeViewer, 1/1.1f, treeViewer.getCenter());
			}
		});
		this.add(minus, BorderLayout.SOUTH);
		this.add(plus, BorderLayout.SOUTH);
	}



	public void onNewBranching(GraphComponent currentComp, BranchSolverStep_old solverStep)
	{
		BranchTreeNode newNode = treeViewer.addNewNode(stack.isEmpty()?null:stack.peek(), currentComp, solverStep);
		stack.push(newNode);
		panel.repaint();
	}
	public void onBranchingReturned(){
		stack.pop();
	}
}
