package visualization.Graph;

import java.awt.Paint;

import main.Node;

import org.apache.commons.collections15.Transformer;

import visualization.GraphChanger;
import visualization.GraphVisColors;
import Utils.GraphUtils;
import Utils.Tuple;

public class EdgeColorTransformer implements Transformer<Tuple<Node, Node>, Paint> {

	//Graph g;
	public EdgeColorTransformer() 
	{
		//this.g = g;
	}

	@Override
	public Paint transform(Tuple<Node, Node> edge) 
	{
		if(GraphChanger.lastAdded.contains(edge))
			return GraphVisColors.lastAdded;
		else if(GraphChanger.lastDeletedEdges.contains(edge))
			return GraphVisColors.lastDeleted;
		else if(edge.left.deleted || edge.right.deleted || !GraphUtils.hasEdge(edge.left, edge.right))
			return GraphVisColors.deleted;
		else
			return GraphVisColors.normal;
	}

}
