package visualization.Graph;


import java.awt.IllegalComponentStateException;

import visualization.GraphChanger;
import visualization.GraphComponent;
import visualization.Graph.GraphViewFrame.BreakPoint;

import main.Graph;

public class GraphViewing
{
	private static GraphViewFrame graphViewer;
	public static void showBeforeChange(Graph g, GraphChanger c, GraphComponent d)
	{
		if(graphViewer == null)
		{
			graphViewer = new GraphViewFrame(g);
			graphViewer.setVisible(true);
			waitForClick();
		}
	}

	public static void showAfterChange(GraphChanger c, GraphComponent d)
	{
		if(graphViewer == null)
			throw new IllegalComponentStateException("No graphViewer created yet on showAfterChange!");

		if(stopNow(c, d))
		{
			graphViewer.drawChanges(c, d);
			waitForClick();
			c.clearChanges();
		}
	}

	private static boolean stopNow(GraphChanger c, GraphComponent d)
	{
		switch(graphViewer.nextStop)
		{
		case nextChange: 
			if(c.hasChanges())
				return true;
			break;
		case nextComponent:
			if(d != graphViewer.currentFocus)
				return true;
			break;
		case nextRule:
			return true;
		case now: 
			throw new IllegalComponentStateException();
		}
		return false;
	}

	private static void waitForClick()
	{
		synchronized(graphViewer)
		{
			graphViewer.nextStop = BreakPoint.now;
			while(graphViewer.nextStop == BreakPoint.now)
			{
				try {
					graphViewer.wait(5000);
				} catch (InterruptedException e) {
				}
			}
		}
	}

	public static void showGraphAndWaitForClose(Graph g, String windowTitle)
	{
		SimpleGraphViewFrame graphviewFrame = new SimpleGraphViewFrame(g, windowTitle);
		graphviewFrame.setVisible(true);
		synchronized(graphviewFrame)
		{
			while(graphviewFrame.isVisible())
			{
				try {
					graphviewFrame.wait(500);
				} catch (InterruptedException e) {
				}
			}
		}
	}
	public static void showGraphAndWaitForClose(Graph g, String windowTitle, GraphComponent component)
	{
		SimpleGraphViewFrame graphviewFrame = new SimpleGraphViewFrame(g, windowTitle);
		graphviewFrame.graphViewer.nodeColTransf.setCurrentComp(component);
		graphviewFrame.setVisible(true);
		synchronized(graphviewFrame)
		{
			while(graphviewFrame.isVisible())
			{
				try {
					graphviewFrame.wait(500);
				} catch (InterruptedException e) {
				}
			}
		}
	}
	
}
