package visualization.Graph;

import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Paint;
import java.awt.Shape;
import java.awt.geom.Ellipse2D;

import javax.swing.JComponent;
import javax.swing.JLabel;
import javax.swing.JPanel;

import visualization.GraphVisColors;

public class Legend extends JPanel 
{
	private static final long serialVersionUID = -8090714328465486139L;

	public Legend() 
	{
		GridBagLayout gridbag = new GridBagLayout();
		GridBagConstraints c = new GridBagConstraints();
		this.setLayout(gridbag);
		//this.setLayout(new GridLayout(5, 2));
		this.setPreferredSize(new Dimension(130, 300));
		
		addLegendEntry(GraphVisColors.normal, "normal", gridbag, c);
		addLegendEntry(GraphVisColors.deleted, "deleted", gridbag, c);
		addLegendEntry(GraphVisColors.lastDeleted, "last deleted", gridbag, c);
		addLegendEntry(GraphVisColors.lastAdded, "last added", gridbag, c);
		addLegendEntry(GraphVisColors.lastDeletedAndAddedNode, "added+deleted", gridbag, c);
	}

	private void addLegendEntry(Paint normalNode, String name, GridBagLayout gridbag, GridBagConstraints c)
	{
		JComponent comp = null;
		this.add(comp = new ColoredCircle(normalNode));
		c.weightx=0;
	//	c.
		c.gridwidth = GridBagConstraints.RELATIVE; 
		gridbag.setConstraints(comp, c);
		
		c.weightx=1;
		c.gridwidth = GridBagConstraints.REMAINDER;
		this.add(comp = new JLabel(name));
		gridbag.setConstraints(comp, c);
	}

	private class ColoredCircle extends JComponent {
		private static final long serialVersionUID = -6873061892409831980L;
		
		Paint color;
		public ColoredCircle(Paint color) 
		{
			this.color = color;
			setSize(25, 25);
			setPreferredSize(new Dimension(25, 25));
		}

		public void paint(Graphics g)
		{
			Graphics2D ga = (Graphics2D)g;
			ga.setStroke(new BasicStroke(3));
			Dimension d = this.getSize();
			int size = Math.min(19, Math.min(d.height-3, d.width-3));
			Shape circle = new Ellipse2D.Float(3, 3, size, size);

			ga.setPaint(Color.black);
			ga.draw(circle);
			ga.setPaint(color);
			ga.fill(circle);
		}
	}
}
