package visualization.Graph;

import java.awt.Paint;

import main.Node;

import org.apache.commons.collections15.Transformer;

import visualization.GraphChanger;
import visualization.GraphComponent;
import visualization.GraphVisColors;

public class NodeColorTransformer implements Transformer<Node, Paint> {

	GraphComponent d;
	public NodeColorTransformer() 
	{
	}

	public void setCurrentComp(GraphComponent d)
	{
		this.d = d;
	}

	@Override
	public Paint transform(Node n) 
	{
		if(d!=null && d.contains(n))
			return GraphVisColors.currentObject;
		else if(GraphChanger.lastDeletedNodes.contains(n))
		{
			if(GraphChanger.lastAddedNodes.contains(n))//this migtht happen if a node added by PRR4 gets deleted by tree reduction rules within the same step
				return GraphVisColors.lastDeletedAndAddedNode;
			else
				return GraphVisColors.lastDeleted;
		}
		else if(GraphChanger.lastAddedNodes.contains(n))
			return GraphVisColors.lastAdded;
		else if(!n.deleted)
			return GraphVisColors.normal;
		else
			return GraphVisColors.deleted;
	}

}
